Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5075)
@@ -6257,9 +6727,11 @@
 
             ! long_name
-            IF( TRIM(td_var%c_longname) == '' .AND. &
-            &   TRIM(tg_varextra(il_varid)%c_longname) /= '' )THEN
-               td_var%c_longname=TRIM(tg_varextra(il_varid)%c_longname)
+            IF( TRIM(tg_varextra(il_ind)%c_longname) /= '' .AND. &
+            &   ( TRIM(td_var%c_longname) == '' .OR. &
+            &     TRIM(tg_varextra(il_ind)%c_longname) /= &
+            &     TRIM(td_var%c_longname) ) )THEN
+               td_var%c_longname=TRIM(tg_varextra(il_ind)%c_longname)
                ! create attibute
-               tl_att=att_init('long_name',TRIM(td_var%c_stdname))
+               tl_att=att_init('long_name',TRIM(td_var%c_longname))
                CALL var_move_att(td_var, tl_att)               
             ENDIF
@@ -6267,6 +6739,6 @@
             ! units
             IF( TRIM(td_var%c_units) == '' .AND. & 
-            &   TRIM(tg_varextra(il_varid)%c_units) /= '' )THEN
-               td_var%c_units=TRIM(tg_varextra(il_varid)%c_units)
+            &   TRIM(tg_varextra(il_ind)%c_units) /= '' )THEN
+               td_var%c_units=TRIM(tg_varextra(il_ind)%c_units)
                ! create attibute
                tl_att=att_init('units',TRIM(td_var%c_units))
@@ -6275,7 +6747,9 @@
 
             ! axis
-            IF( TRIM(td_var%c_axis) == '' .AND. & 
-            &   TRIM(tg_varextra(il_varid)%c_axis) /= '' )THEN
-               td_var%c_axis=TRIM(tg_varextra(il_varid)%c_axis)
+            IF( TRIM(tg_varextra(il_ind)%c_axis) /= '' .AND. &
+            &   ( TRIM(td_var%c_axis) == '' .OR. & 
+            &     TRIM(tg_varextra(il_ind)%c_axis) /= &
+            &     TRIM(td_var%c_axis) ) )THEN
+               td_var%c_axis=TRIM(tg_varextra(il_ind)%c_axis)
                ! create attibute
                tl_att=att_init('axis',TRIM(td_var%c_axis))
@@ -6284,12 +6758,16 @@
 
             ! grid point
-            IF( TRIM(td_var%c_point) == '' .AND. &
-            &   TRIM(tg_varextra(il_varid)%c_point) /= '' )THEN
-               td_var%c_point=TRIM(tg_varextra(il_varid)%c_point)
+            IF( TRIM(tg_varextra(il_ind)%c_point) /= '' .AND. &
+            &   ( TRIM(td_var%c_point) == '' .OR. &
+            &     TRIM(tg_varextra(il_ind)%c_point) /= &
+            &     TRIM(td_var%c_point) ) )THEN
+               td_var%c_point=TRIM(tg_varextra(il_ind)%c_point)
             ELSE
-               CALL logger_warn("VAR GET EXTRA: unknown grid point "//&
-               &  "for variable "//TRIM(td_var%c_name)//&
-               &  ". assume it is a T-point.")
-               td_var%c_point='T'
+               IF( TRIM(td_var%c_point) == '' )THEN
+                  CALL logger_warn("VAR GET EXTRA: unknown grid point "//&
+                  &  "for variable "//TRIM(td_var%c_name)//&
+                  &  ". assume it is a T-point.")
+                  td_var%c_point='T'
+               ENDIF
             ENDIF
             ! create attibute
@@ -6297,32 +6775,35 @@
             CALL var_move_att(td_var, tl_att)               
 
+            ! clean
+            CALL att_clean(tl_att)
+
             ! interp
             IF( TRIM(td_var%c_interp(1)) == '' .AND. &
-            &   TRIM(tg_varextra(il_varid)%c_interp(1)) /= '' )THEN
-               td_var%c_interp(:)=tg_varextra(il_varid)%c_interp(:)
+            &   TRIM(tg_varextra(il_ind)%c_interp(1)) /= '' )THEN
+               td_var%c_interp(:)=tg_varextra(il_ind)%c_interp(:)
             ENDIF
 
             ! extrap
             IF( TRIM(td_var%c_extrap(1)) == '' .AND. &
-            &   TRIM(tg_varextra(il_varid)%c_extrap(1)) /= '' )THEN
-               td_var%c_extrap(:)=tg_varextra(il_varid)%c_extrap(:)
+            &   TRIM(tg_varextra(il_ind)%c_extrap(1)) /= '' )THEN
+               td_var%c_extrap(:)=tg_varextra(il_ind)%c_extrap(:)
             ENDIF
 
             ! filter
             IF( TRIM(td_var%c_filter(1)) == '' .AND. &
-            &   TRIM(tg_varextra(il_varid)%c_filter(1)) /= '' )THEN
-               td_var%c_filter(:)=tg_varextra(il_varid)%c_filter(:)
+            &   TRIM(tg_varextra(il_ind)%c_filter(1)) /= '' )THEN
+               td_var%c_filter(:)=tg_varextra(il_ind)%c_filter(:)
             ENDIF            
 
             ! min value
-            IF( td_var%d_min == dg_fill .AND. &
-            &   tg_varextra(il_varid)%d_min /= dg_fill )THEN
-               td_var%d_min=tg_varextra(il_varid)%d_min
+            IF( td_var%d_min == dp_fill .AND. &
+            &   tg_varextra(il_ind)%d_min /= dp_fill )THEN
+               td_var%d_min=tg_varextra(il_ind)%d_min
             ENDIF
 
             ! max value
-            IF( td_var%d_max == dg_fill .AND. &
-            &   tg_varextra(il_varid)%d_max /= dg_fill )THEN
-               td_var%d_max=tg_varextra(il_varid)%d_max
+            IF( td_var%d_max == dp_fill .AND. &
+            &   tg_varextra(il_ind)%d_max /= dp_fill )THEN
+               td_var%d_max=tg_varextra(il_ind)%d_max
             ENDIF
 
@@ -6346,9 +6827,8 @@
 
    END SUBROUTINE var__get_extra
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !> This function check if variable information read in namelist contains 
-   !> minimum value and return it if true 
+   !> minimum value and return it if true. 
    !> 
    !> @details
@@ -6356,9 +6836,10 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_varinfo : variable information read in namelist 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name      variable name
+   !> @param[in] cd_varinfo   variable information read in namelist 
+   !> @return minimum value to be used (FillValue if none)
+   !-------------------------------------------------------------------
    FUNCTION var__get_min( cd_name, cd_varinfo )
       IMPLICIT NONE
@@ -6381,5 +6862,5 @@
       ! init
       cl_min=''
-      var__get_min=dg_fill
+      var__get_min=dp_fill
 
       ji=1
@@ -6398,5 +6879,5 @@
          IF( fct_is_num(cl_min) )THEN
             READ(cl_min,*) var__get_min
-            CALL logger_info("VAR GET MIN: will use minimum value of "//&
+            CALL logger_debug("VAR GET MIN: will use minimum value of "//&
             &  TRIM(fct_str(var__get_min))//" for variable "//TRIM(cd_name) )
          ELSE
@@ -6407,9 +6888,8 @@
 
    END FUNCTION var__get_min
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !> This function check if variable information read in namelist contains 
-   !> maximum value and return it if true 
+   !> maximum value and return it if true. 
    !> 
    !> @details
@@ -6417,9 +6897,10 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_varinfo : variable information read in namelist 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name      variable name
+   !> @param[in] cd_varinfo   variable information read in namelist 
+   !> @return maximum value to be used (FillValue if none)
+   !-------------------------------------------------------------------
    FUNCTION var__get_max( cd_name, cd_varinfo )
       IMPLICIT NONE
@@ -6442,5 +6923,5 @@
       ! init
       cl_max=''
-      var__get_max=dg_fill
+      var__get_max=dp_fill
 
       ji=1
@@ -6459,5 +6940,5 @@
          IF( fct_is_num(cl_max) )THEN
             READ(cl_max,*) var__get_max
-            CALL logger_info("VAR GET MAX: will use maximum value of "//&
+            CALL logger_debug("VAR GET MAX: will use maximum value of "//&
             &  TRIM(fct_str(var__get_max))//" for variable "//TRIM(cd_name) )
          ELSE
@@ -6468,18 +6949,26 @@
 
    END FUNCTION var__get_max
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !> This function check if variable information read in namelist contains 
-   !> interpolation method and return it if true 
+   !> interpolation method and return it if true. 
    !> 
    !> @details 
+   !> split namelist information, using ';' as separator.
+   !> compare method name with the list of interpolation method available (see
+   !> module global).
+   !> check if factor (*rhoi, /rhoj..) are present.<br/>
+   !> Example:<br/> 
+   !> - cubic/rhoi ; dist_weight
+   !> - bilin
+   !> see @ref interp module for more information.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_varinfo : variable information read in namelist 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name      variable name
+   !> @param[in] cd_varinfo   variable information read in namelist
+   !> @return array of character information about interpolation 
+   !-------------------------------------------------------------------
    FUNCTION var__get_interp( cd_name, cd_varinfo )
       IMPLICIT NONE
@@ -6511,10 +7000,10 @@
       cl_tmp=fct_split(cd_varinfo,ji,';')
       DO WHILE( TRIM(cl_tmp) /= '' )
-         DO jj=1,ig_ninterp
-            il_ind= INDEX(fct_lower(cl_tmp),TRIM(cg_interp_list(jj)))
+         DO jj=1,ip_ninterp
+            il_ind= INDEX(fct_lower(cl_tmp),TRIM(cp_interp_list(jj)))
             IF( il_ind /= 0 )THEN
 
-               var__get_interp(1)=TRIM(cg_interp_list(jj))
-               il_len=LEN(TRIM(cg_interp_list(jj)))
+               var__get_interp(1)=TRIM(cp_interp_list(jj))
+               il_len=LEN(TRIM(cp_interp_list(jj)))
                
                ! look for factor
@@ -6563,5 +7052,5 @@
             ENDIF
          ENDDO
-         IF( jj /= ig_ninterp + 1 ) EXIT
+         IF( jj /= ip_ninterp + 1 ) EXIT
          ji=ji+1
          cl_tmp=fct_split(cd_varinfo,ji,';')         
@@ -6569,18 +7058,25 @@
 
    END FUNCTION var__get_interp
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !> This function check if variable information read in namelist contains 
-   !> extrapolation method and return it if true 
+   !> extrapolation method and return it if true. 
    !> 
    !> @details 
+   !> split namelist information, using ';' as separator.
+   !> compare method name with the list of extrapolation method available (see
+   !> module global).<br/>
+   !> Example:<br/>
+   !> - cubic ; dist_weight
+   !> - min_error
+   !> see @ref extrap module for more information.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_varinfo : variable information read in namelist 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name      variable name
+   !> @param[in] cd_varinfo   variable information read in namelist
+   !> @return array of character information about extrapolation
+   !-------------------------------------------------------------------
    FUNCTION var__get_extrap( cd_name, cd_varinfo )
       IMPLICIT NONE
@@ -6605,9 +7101,9 @@
       cl_tmp=fct_split(cd_varinfo,ji,';')
       DO WHILE( TRIM(cl_tmp) /= '' )
-         DO jj=1,ig_nextrap
-            IF( TRIM(fct_lower(cl_tmp)) == TRIM(cg_extrap_list(jj)) )THEN
-               var__get_extrap(1)=TRIM(cg_extrap_list(jj))
-
-               CALL logger_info("VAR GET EXTRAP: variable "//TRIM(cd_name)//&
+         DO jj=1,ip_nextrap
+            IF( TRIM(fct_lower(cl_tmp)) == TRIM(cp_extrap_list(jj)) )THEN
+               var__get_extrap(1)=TRIM(cp_extrap_list(jj))
+
+               CALL logger_trace("VAR GET EXTRAP: variable "//TRIM(cd_name)//&
                &  " will use extrapolation method "//TRIM(var__get_extrap(1)) )
 
@@ -6615,5 +7111,5 @@
             ENDIF
          ENDDO
-         IF( jj /= ig_nextrap + 1 ) EXIT
+         IF( jj /= ip_nextrap + 1 ) EXIT
          ji=ji+1
          cl_tmp=fct_split(cd_varinfo,ji,';')         
@@ -6622,5 +7118,4 @@
 
    END FUNCTION var__get_extrap
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -6629,11 +7124,20 @@
    !> 
    !> @details 
+   !> split namelist information, using ';' as separator.
+   !> compare method name with the list of filter method available (see
+   !> module global).
+   !> look for the number of turn, using '*' separator, and method parameters inside
+   !> bracket.<br/>
+   !> Example:<br/>
+   !> - cubic ; 2*hamming(2,3)
+   !> - hann
+   !> see @ref filter module for more information.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_varinfo : variable information read in namelist 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name      variable name
+   !> @param[in] cd_varinfo   variable information read in namelist 
+   !-------------------------------------------------------------------
    FUNCTION var__get_filter( cd_name, cd_varinfo )
       IMPLICIT NONE
@@ -6659,8 +7163,8 @@
       cl_tmp=fct_split(cd_varinfo,ji,';')
       DO WHILE( TRIM(cl_tmp) /= '' )
-         DO jj=1,ig_nfilter
-            il_ind=INDEX(fct_lower(cl_tmp),TRIM(cg_filter_list(jj)))
+         DO jj=1,ip_nfilter
+            il_ind=INDEX(fct_lower(cl_tmp),TRIM(cp_filter_list(jj)))
             IF( il_ind /= 0 )THEN
-               var__get_filter(1)=TRIM(cg_filter_list(jj))
+               var__get_filter(1)=TRIM(cp_filter_list(jj))
 
                ! look for number of turn
@@ -6711,5 +7215,5 @@
             ENDIF
          ENDDO
-         IF( jj /= ig_nfilter + 1 ) EXIT
+         IF( jj /= ip_nfilter + 1 ) EXIT
          ji=ji+1
          cl_tmp=fct_split(cd_varinfo,ji,';')         
@@ -6717,18 +7221,15 @@
 
    END FUNCTION var__get_filter
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
    !> This function search and save the biggest dimensions use 
-   !> in those variables.
-   !>
-   !
+   !> in an array of variable structure.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : table of variable structure
-   !> @return table of dimension 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var array of variable structure
+   !> @return array of dimension 
+   !-------------------------------------------------------------------
    FUNCTION var_max_dim(td_var)
       IMPLICIT NONE
@@ -6749,44 +7250,43 @@
       il_nvar=SIZE(td_var(:))
                           
-      var_max_dim(:)=td_var(1)%t_dim(:)
-
-      DO ji=2,il_nvar     
-                          
-         IF( td_var(ji)%t_dim(1)%l_use .AND. &
-         &   td_var(ji)%t_dim(1)%i_len >= var_max_dim(1)%i_len )THEN
-            var_max_dim(1)=td_var(ji)%t_dim(1)
-         ENDIF            
-                          
-         IF( td_var(ji)%t_dim(2)%l_use .AND. &
-         &   td_var(ji)%t_dim(2)%i_len >= var_max_dim(2)%i_len )THEN 
-            var_max_dim(2)=td_var(ji)%t_dim(2)
-         ENDIF            
-                          
-         IF( td_var(ji)%t_dim(3)%l_use .AND. &
-         &   td_var(ji)%t_dim(3)%i_len >= var_max_dim(3)%i_len )THEN 
-            var_max_dim(3)=td_var(ji)%t_dim(3)
-         ENDIF            
-                          
-         IF( td_var(ji)%t_dim(4)%l_use .AND. &
-         &   td_var(ji)%t_dim(4)%i_len >= var_max_dim(4)%i_len )THEN
-            var_max_dim(4)=td_var(ji)%t_dim(4)
-         ENDIF
-
-      ENDDO
+      var_max_dim(:)=dim_copy(td_var(1)%t_dim(:))
+
+      IF( il_nvar > 1 )THEN
+         DO ji=2,il_nvar     
+                             
+            IF( td_var(ji)%t_dim(1)%l_use .AND. &
+            &   td_var(ji)%t_dim(1)%i_len >= var_max_dim(1)%i_len )THEN
+               var_max_dim(1)=dim_copy(td_var(ji)%t_dim(1))
+            ENDIF            
+                             
+            IF( td_var(ji)%t_dim(2)%l_use .AND. &
+            &   td_var(ji)%t_dim(2)%i_len >= var_max_dim(2)%i_len )THEN 
+               var_max_dim(2)=dim_copy(td_var(ji)%t_dim(2))
+            ENDIF            
+                             
+            IF( td_var(ji)%t_dim(3)%l_use .AND. &
+            &   td_var(ji)%t_dim(3)%i_len >= var_max_dim(3)%i_len )THEN 
+               var_max_dim(3)=dim_copy(td_var(ji)%t_dim(3))
+            ENDIF            
+                             
+            IF( td_var(ji)%t_dim(4)%l_use .AND. &
+            &   td_var(ji)%t_dim(4)%i_len >= var_max_dim(4)%i_len )THEN
+               var_max_dim(4)=dim_copy(td_var(ji)%t_dim(4))
+            ENDIF
+
+         ENDDO
+      ENDIF
 
    END FUNCTION var_max_dim
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine forced minimum and maximum value of variable.
+   !> This subroutine forced minimum and maximum value of variable,
+   !> with value of variable structure attribute d_min and d_max.
    !> 
-   !> @details 
-   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE var_limit_value( td_var )
       IMPLICIT NONE
@@ -6801,5 +7301,5 @@
       IF( ASSOCIATED(td_var%d_value) )THEN
          !1- forced minimum value
-         IF( td_var%d_min /= dg_fill )THEN
+         IF( td_var%d_min /= dp_fill )THEN
             WHERE( td_var%d_value(:,:,:,:) /= td_var%d_fill .AND. &
                &   td_var%d_value(:,:,:,:) <  td_var%d_min )
@@ -6809,5 +7309,5 @@
 
          !2- forced maximum value 
-         IF( td_var%d_max /= dg_fill )THEN
+         IF( td_var%d_max /= dp_fill )THEN
             WHERE( td_var%d_value(:,:,:,:) /= td_var%d_fill .AND. &
                &   td_var%d_value(:,:,:,:) >  td_var%d_max )
@@ -6819,17 +7319,18 @@
 
    END SUBROUTINE var_limit_value
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine forced minimum and maximum value of variable.
+   !> This subroutine check variable dimension expected, as defined in
+   !> file 'variable.cfg'.
    !> 
    !> @details 
+   !> compare dimension used in variable structure with string character
+   !> axis from configuration file. 
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var    variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE var_check_dim( td_var )
       IMPLICIT NONE
@@ -6879,13 +7380,17 @@
             CALL logger_warn("VAR CHECK DIM: too much dimension for "//&
             &                "variable "//TRIM(td_var%c_name)//".")
+            cl_dim=TRIM(fct_upper(cp_dimorder))
+            il_ndim =LEN( TRIM(ADJUSTL(cl_dim)) )
             DO ji=1,il_ndim 
                IF( INDEX(TRIM(td_var%c_axis),cl_dim(ji:ji)) == 0 )THEN
-                  IF( td_var%t_dim(ji)%i_len == 1 )THEN
-                     ! remove unuseful dimension
-                     CALL var_del_dim(td_var,td_var%t_dim(ji))
-                  ELSE
-                     CALL logger_warn("VAR CHECK DIM: variable "//&
-                     &           TRIM(td_var%c_name)//" should not use"//&
-                     &           " dimension "//TRIM(td_var%t_dim(ji)%c_name))
+                  IF( td_var%t_dim(ji)%l_use )THEN
+                     IF( td_var%t_dim(ji)%i_len == 1 )THEN
+                        ! remove unuseful dimension
+                        CALL var_del_dim(td_var,td_var%t_dim(ji))
+                     ELSE
+                        CALL logger_warn("VAR CHECK DIM: variable "//&
+                        &           TRIM(td_var%c_name)//" should not use"//&
+                        &           " dimension "//TRIM(td_var%t_dim(ji)%c_name))
+                     ENDIF
                   ENDIF
                ENDIF
@@ -6898,5 +7403,154 @@
 
    END SUBROUTINE var_check_dim
-   !> @endcode
+   !-------------------------------------------------------------------
+   !> @brief
+   !> This subroutine reshape variable value and dimension 
+   !> in variable structure.
+   !> @details
+   !> output dimension will be ordered as defined in 
+   !> input array of dimension
+   !> Optionaly you could specify output dimension order with
+   !> string character of dimension
+   !> 
+   !> @author J.Paul
+   !> - August, 2014- Initial Version
+   !
+   !> @param[inout] td_var       variable structure
+   !> @param[in]    cd_dimorder  string character of dimension order to be used
+   !-------------------------------------------------------------------
+   SUBROUTINE var_reorder( td_var, cd_dimorder )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TVAR)              , INTENT(INOUT) :: td_var
+      CHARACTER(LEN=ip_maxdim), INTENT(IN   ), OPTIONAL :: cd_dimorder
+
+      ! local variable
+      CHARACTER(LEN=lc)                             :: cl_dimorder
+
+      REAL(dp)  , DIMENSION(:,:,:,:)  , ALLOCATABLE :: dl_value
+
+      TYPE(TDIM), DIMENSION(ip_maxdim)              :: tl_dim
+
+      ! loop indices
+      !----------------------------------------------------------------
+
+      cl_dimorder=TRIM(cp_dimorder)
+      IF( PRESENT(cd_dimorder) ) cl_dimorder=TRIM(ADJUSTL(cd_dimorder))
+
+      tl_dim(:)=dim_copy(td_var%t_dim(:))
+
+      CALL dim_unorder(tl_dim(:))
+      CALL dim_reorder(tl_dim(:),TRIM(cl_dimorder))
+
+      ALLOCATE(dl_value(tl_dim(1)%i_len, &
+      &                 tl_dim(2)%i_len, &
+      &                 tl_dim(3)%i_len, &
+      &                 tl_dim(4)%i_len ))
+
+      dl_value(:,:,:,:)=dim_reshape_2xyzt(tl_dim, &
+      &                                   td_var%d_value(:,:,:,:))
+
+      ! change dimension
+      td_var%t_dim(:)=dim_copy(tl_dim(:))
+      ! change value
+      DEALLOCATE( td_var%d_value )
+      CALL var_add_value(td_var, dl_value(:,:,:,:))
+
+      ! clean
+      DEALLOCATE(dl_value)
+      CALL dim_clean(tl_dim(:))
+
+   END SUBROUTINE var_reorder
+   !-------------------------------------------------------------------
+   !> @brief
+   !> This function get the next unused unit in array of variable structure. 
+   !> 
+   !> @author J.Paul
+   !> - September, 2014- Initial Version
+   !
+   !> @param[in] td_var array of variable structure 
+   !> @return free variable id
+   !-------------------------------------------------------------------
+   FUNCTION var_get_unit(td_var)
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TVAR), DIMENSION(:), INTENT(IN) :: td_var
+
+      ! function
+      INTEGER(i4) :: var_get_unit
+
+      ! local variable
+      ! loop indices
+      !----------------------------------------------------------------
+
+      var_get_unit=MAXVAL(td_var(:)%i_id)+1
+
+   END FUNCTION var_get_unit
+   !-------------------------------------------------------------------
+   !> @brief
+   !> This function convert a time variable structure in date structure. 
+   !> 
+   !> @author J.Paul
+   !> - November, 2014- Initial Version
+   !
+   !> @param[in] td_var time variable structure 
+   !> @return date structure
+   !-------------------------------------------------------------------
+   FUNCTION var_to_date(td_var)
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TVAR), INTENT(IN) :: td_var
+
+      ! function
+      TYPE(TDATE) :: var_to_date
+
+      ! local variable
+      CHARACTER(LEN=lc) :: cl_step
+      CHARACTER(LEN=lc) :: cl_date
+
+      INTEGER(i4) :: il_attid
+
+      INTEGER(i8) :: kl_nsec
+
+      TYPE(TDATE) :: tl_dateo
+      ! loop indices
+      !----------------------------------------------------------------
+
+      IF( INDEX(TRIM(td_var%c_name),'time') /= 0 )THEN
+         IF( ASSOCIATED(td_var%d_value) )THEN
+
+            il_attid=att_get_index(td_var%t_att(:),'units')
+            IF( il_attid /=0 )THEN
+               cl_step=fct_split(td_var%t_att(il_attid)%c_value,1,'since')
+               cl_date=fct_split(td_var%t_att(il_attid)%c_value,2,'since')
+
+               SELECT CASE(TRIM(cl_step))
+                  CASE('seconds')
+                     kl_nsec=INT(td_var%d_value(1,1,1,1),i8)
+                  CASE('days')
+                     kl_nsec=INT(td_var%d_value(1,1,1,1)*86400,i8)
+                  CASE DEFAULT
+                     CALL logger_error("VAR TO DATE: unknown units format "//&
+                     &  "in variable "//TRIM(td_var%c_name))
+               END SELECT
+
+               tl_dateo=date_init(cl_date)
+
+               var_to_date=date_init(kl_nsec,tl_dateo)
+
+            ELSE
+               CALL logger_error("VAR TO DATE: no attribute units in "//&
+               &  "variable "//TRIM(td_var%c_name))
+            ENDIF
+         ELSE
+            CALL logger_error("VAR TO DATE: no value associated to "//&
+            &  "variable "//TRIM(td_var%c_name))
+         ENDIF
+      ELSE
+         CALL logger_error("VAR TO DATE: variable "//TRIM(td_var%c_name)//&
+         &  "can not be convert in date.")
+      ENDIF
+
+   END FUNCTION var_to_date
 END MODULE var
 
